/* 
 * File:   user.h
 * Mp3_05
 * 
 * Created on 2015/09/20, 8:10
 */

#ifndef USER_H
#define	USER_H

#ifdef	__cplusplus
extern "C" {
#endif

// for compatibility with XC8(stdint.h)
typedef unsigned int8   uint8_t;
typedef unsigned int16  uint16_t;
typedef unsigned int32  uint32_t;

#define itoc(x)             ('0' + (x))
#define itoh(x)             ('A' + ((x) - 10))
#define itoH(x)             ((x) < 10 ? ('0' + (x)) : ('A' + ((x) - 10)))

// vs1063.c
void    VS1063_HardwareReset();
void    VS1063_SoftwareReset();
int8    VS1063_Decode(char *Mp3FileName, FIL *file, uint16_t bytespersec);
int8    VS1063_MonitorMode();
int8    VS1063_Encode(char *Mp3FileName, FIL *file, uint8_t CurEncSet, uint16_t recno);
uint16_t VS1063_ReadSci(uint8_t addr);
void    VS1063_WriteSci(uint8_t addr, uint16_t val);
uint16_t VS1063_ReadWram(uint16_t addr);
void    VS1063_SetVolume(uint16_t volume);

// at24c128.c
uint8_t AT24C128_Write(uint16_t address, uint8_t data);
uint8_t AT24C128_Read(uint16_t address, uint8_t *data);
uint8_t AT24C128_SeqRead_Start(uint16_t address);
uint8_t AT24C128_SeqRead_Read(uint8_t *data, uint16_t readbytes);
uint8_t AT24C128_SeqRead_Stop();
uint8_t AT24C128_Read_Word(uint16_t address, uint16_t *data);
uint8_t AT24C128_Test();

// m41t62.c
uint8_t RTC_Write(uint8_t startaddress, uint8_t numbytes, uint8_t bytes[]);
uint8_t RTC_Read(uint8_t startaddress, uint8_t numbytes, uint8_t bytes[]);
uint8_t RTC_Reset();
uint8_t RTC_Init();
uint8_t RTC_SetDateTime(char *datetime);
uint8_t RTC_GetCurrentDateYYMMDD(char *buff);
uint8_t RTC_GetCurrentTimeHHMMSS(char *buff);
uint8_t RTC_GetCurrentDateTimeBCD(uint8_t *dt);
uint8_t RTC_GetCurrentDateTimeForAdjust(char *buff);
uint8_t RTC_GetCurrentDateTimeForDisp(char *buff);
uint8_t RTC_SetAlarm(uint8_t *YMDHMS);
uint8_t RTC_GetFlags();
uint8_t RTC_GetAllRegisterToStr(char *buff);
uint8_t RTC_GetAllRegister(uint8_t *buff);
uint8_t RTC_ClearAlarm();
uint8_t RTC_STbitOnOff();
uint8_t RTC_ResetFlags();

// lcd.c
uint8_t LCD_I2C_Start();
uint8_t LCD_Init();
void LCD_Locate(unsigned char line, unsigned char column);
void LCD_NPrintln(const unsigned char *str, unsigned char n);
void LCD_Println(const unsigned char *str);
void LCD_LPrintln(unsigned char line, const unsigned char *str);
void LCD_LCPrintln(unsigned char line, unsigned char column, const unsigned char *str);
void LCD_Disp_Sd_Ng();
void LCD_RadioMode_Line0(uint8_t FmAm, char *stname);
void LCD_Recording_Line1(char *label);
void LCD_Icon_RadioMode(BOOLEAN on);
void LCD_Icon_PlaybackMode(BOOLEAN on);
void LCD_Icon_EncodeDecode(BOOLEAN on);

// si4735.c
uint8_t Si4735_SendCommand(uint8_t Cmd, uint8_t numofargs, uint8_t args[]);
uint8_t Si4735_WaitResponse(uint8_t *status);
uint8_t Si4735_WaitResponseWithValue(uint8_t *status, uint8_t numofval, uint8_t value[]);
uint8_t Si4735_PowerUpFm();
uint8_t Si4735_PowerUpAm();
uint8_t Si4735_PowerDown();
uint8_t Si4735_RclkSettings();
uint8_t Si4735_Volume(uint16_t volume);
uint8_t Si4735_DeemphasisFm();
uint8_t Si4735_AmChannelFilter(uint16_t filter);
uint8_t Si4735_TuneFrequencyFm(uint16_t f_10K);
uint8_t Si4735_TuneFrequencyAm(uint16_t f_1K);
uint8_t Si4735_FmBlendStereoThreshold(uint8_t threshold);
uint8_t Si4735_FmBlendMonoThreshold(uint8_t BlendMonoThreshold);
uint8_t Si4735_GetRev();
uint8_t Si4735_DisableFmDebugFeature();
void Si4735_InitFm(uint8_t CurEncSet);
void Si4735_InitAm();

    
//#define	wait_ms(m)		delay_ms(m)


#ifdef	__cplusplus
}
#endif

#endif	/* USER_H */

